## ros-iron-pybind11-vendor 3.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(pybind11_vendor)

find_package(ament_cmake REQUIRED)

option(FORCE_BUILD_VENDOR_PKG
  "Build pybind11 from source, even if system-installed package is available"
  OFF)

if(NOT FORCE_BUILD_VENDOR_PKG)
  find_package(pybind11 QUIET)
endif()

macro(build_pybind11)
  set(extra_cmake_args)

  # CMAKE_BUILD_TYPE was removed in ros2:pybind11_vendor#3 to eliminate warning
  # on Windows about unused variable. It is only used for tests, which we are
  # not building, and in pybind11Tools.cmake for Linux and Mac. In any case,
  # pybind11 is a headers-only class and does not require building at the time
  # of this vendor package, thus does not require passing in the variable here.
  # It will use the variable value in packages that depend on it for compiling.

  if(DEFINED CMAKE_TOOLCHAIN_FILE)
    list(APPEND extra_cmake_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}")
    if(ANDROID)
      if(DEFINED ANDROID_ABI)
        list(APPEND extra_cmake_args "-DANDROID_ABI=${ANDROID_ABI}")
      endif()
      if(DEFINED ANDROID_CPP_FEATURES)
        list(APPEND extra_cmake_args "-DANDROID_CPP_FEATURES=${ANDROID_CPP_FEATURES}")
      endif()
      if(DEFINED ANDROID_FUNCTION_LEVEL_LINKING)
        list(APPEND extra_cmake_args "-DANDROID_FUNCTION_LEVEL_LINKING=${ANDROID_FUNCTION_LEVEL_LINKING}")
      endif()
      if(DEFINED ANDROID_NATIVE_API_LEVEL)
        list(APPEND extra_cmake_args "-DANDROID_NATIVE_API_LEVEL=${ANDROID_NATIVE_API_LEVEL}")
      endif()
      if(DEFINED ANDROID_NDK)
        list(APPEND extra_cmake_args "-DANDROID_NDK=${ANDROID_NDK}")
      endif()
      if(DEFINED ANDROID_STL)
        list(APPEND extra_cmake_args "-DANDROID_STL=${ANDROID_STL}")
      endif()
      if(DEFINED ANDROID_TOOLCHAIN_NAME)
        list(APPEND extra_cmake_args "-DANDROID_TOOLCHAIN_NAME=${ANDROID_TOOLCHAIN_NAME}")
      endif()
    endif()
  else()
    list(APPEND extra_cmake_args "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
  endif()
  list(APPEND extra_cmake_args "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}")

  include(ExternalProject)
  ExternalProject_Add(pybind11-2.9.1
    GIT_REPOSITORY https://github.com/pybind/pybind11.git
    GIT_TAG ffa346860b306c9bbfb341aed9c14c067751feb8  # v2.9.1
    GIT_CONFIG advice.detachedHead=false
    # Suppress git update due to https://gitlab.kitware.com/cmake/cmake/-/issues/16419
    # See https://github.com/ament/uncrustify_vendor/pull/22 for details
    UPDATE_COMMAND ""
    TIMEOUT 300
    CMAKE_ARGS
      -DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_install
      -DPYBIND11_TEST=OFF
      -DCMAKE_INSTALL_INCLUDEDIR=include/${PROJECT_NAME}
      ${extra_cmake_args}
    # By default, pybind11 sets Py_DEBUG if the interpreter is a debug one (as
    # it is in Windows Debug).  Unfortunately, this conflicts with Py_DEBUG as
    # used by the CPython headers, and ultimately ends up causing multiple
    # definitions for Py_DEBUG, which MSVC complains about.  This patch switches
    # the internal pybind11 variable to be called PYBIND11_DEBUG, which avoids
    # the issue.
    PATCH_COMMAND
      ${CMAKE_COMMAND} -E chdir <SOURCE_DIR> git apply -p1 --ignore-space-change --whitespace=nowarn
        ${CMAKE_CURRENT_SOURCE_DIR}/pybind11-2.9.1-fix-windows-debug.patch
    COMMAND
      ${CMAKE_COMMAND} -E chdir <SOURCE_DIR> git apply -p1 --ignore-space-change --whitespace=nowarn
        ${CMAKE_CURRENT_SOURCE_DIR}/pybind11-python-3.11.patch
  )

  # The external project will install to the build folder, but we'll install that on make install.
  install(
    DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_install/
    DESTINATION
      ${CMAKE_INSTALL_PREFIX}
    USE_SOURCE_PERMISSIONS
  )
endmacro()

if(NOT pybind11_FOUND)
  build_pybind11()
endif()

ament_package(CONFIG_EXTRAS_POST "${PROJECT_NAME}-extras.cmake")

=== debian/changelog ===
ros-iron-pybind11-vendor (3.0.3-3jammy) jammy; urgency=high

  * Add a modified patch from upstream to support Python 3.11 (#22 <https://github.com/ros2/pybind11_vendor/issues/22>)
  * Contributors: Scott K Logan

 -- Scott K Logan <scott@openrobotics.org>  Tue, 11 Apr 2023 07:00:00 -0000

ros-iron-pybind11-vendor (3.0.2-3jammy) jammy; urgency=high

  * Add missing buildtool dependency on git (#19 <https://github.com/ros2/pybind11_vendor/issues/19>)
  * Update maintainers (#17 <https://github.com/ros2/pybind11_vendor/issues/17>)
  * Contributors: Audrow Nash, Scott K Logan

 -- Scott K Logan <scott@openrobotics.org>  Tue, 06 Dec 2022 08:00:00 -0000

ros-iron-pybind11-vendor (3.0.1-3jammy) jammy; urgency=high

  * Force pybind11 to find Python 3. (#15 <https://github.com/ros2/pybind11_vendor/issues/15>)
  * Contributors: Chris Lalancette

 -- Scott K Logan <scott@openrobotics.org>  Wed, 02 Nov 2022 07:00:00 -0000

ros-iron-pybind11-vendor (3.0.0-3jammy) jammy; urgency=high

  * Mirror rolling to master
  * Update maintainers (#14 <https://github.com/ros2/pybind11_vendor/issues/14>)
  * Update to pybind11 2.9.1.
  * Rename patch file for history continuity.
  * Contributors: Audrow Nash, Steven! Ragnarök, methylDragon

 -- Scott K Logan <scott@openrobotics.org>  Tue, 13 Sep 2022 07:00:00 -0000

ros-iron-pybind11-vendor (2.4.0-3jammy) jammy; urgency=high

  * Use sha256 hash instead of tag (#12 <https://github.com/ros2/pybind11_vendor/issues/12>)
  * Install headers to include/${PROJECT_NAME} (#11 <https://github.com/ros2/pybind11_vendor/issues/11>)
  * Contributors: Shane Loretz

 -- Scott K Logan <scott@openrobotics.org>  Mon, 28 Mar 2022 07:00:00 -0000

ros-iron-pybind11-vendor (2.3.0-3jammy) jammy; urgency=high

  * Update pybind11 to 2.7.1. (#10 <https://github.com/ros2/pybind11_vendor/issues/10>)
    This is the version that is shipped in Ubuntu 22.04.
  * Contributors: Chris Lalancette

 -- Scott K Logan <scott@openrobotics.org>  Fri, 14 Jan 2022 08:00:00 -0000

ros-iron-pybind11-vendor (2.2.6-3jammy) jammy; urgency=high

  * Update maintainers (#7 <https://github.com/ros2/pybind11_vendor/issues/7>)
  * Contributors: Shane Loretz

 -- Scott K Logan <scott@openrobotics.org>  Thu, 10 Dec 2020 08:00:00 -0000

ros-iron-pybind11-vendor (2.2.5-3jammy) jammy; urgency=high

  * Merge pull request #3 <https://github.com/ros2/pybind11_vendor/issues/3> from ros2/fix_windows_warning
  * remove passing in CMAKE_BUILD_TYPE
    Signed-off-by: Mabel Zhang <mailto:mabel@openrobotics.org>
  * cleanup
    Signed-off-by: Mabel Zhang <mailto:mabel@openrobotics.org>
  * do not define CMAKE_BUILD_TYPE on windows
    Signed-off-by: Mabel Zhang <mailto:mabel@openrobotics.org>
  * suppress all developer warnings
    Signed-off-by: Mabel Zhang <mailto:mabel@openrobotics.org>
  * suppress warning on windows
    Signed-off-by: Mabel Zhang <mailto:mabel@openrobotics.org>
  * attempt to fix windows warning
    Signed-off-by: Mabel Zhang <mailto:mabel@openrobotics.org>
  * Disable building pybind11 tests (#1 <https://github.com/ros2/pybind11_vendor/issues/1>)
    Signed-off-by: Karsten Knese <mailto:karsten@openrobotics.org>
  * Update to pybind 2.5.0 (#2 <https://github.com/ros2/pybind11_vendor/issues/2>)
    Signed-off-by: Mabel Zhang <mailto:mabel@openrobotics.org>
  * Create pybind11 vendor package.
    Signed-off-by: Michael Carroll <mailto:michael@openrobotics.org>
  * Contributors: Karsten Knese, Mabel Zhang, Michael Carroll

 -- Scott K Logan <scott@openrobotics.org>  Mon, 17 Aug 2020 07:00:00 -0000

=== debian/control ===
Source: ros-iron-pybind11-vendor
Section: misc
Priority: optional
Maintainer: Scott K Logan <scott@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), git, pybind11-dev, ros-iron-ament-cmake, ros-iron-ros-workspace
Homepage: https://github.com/pybind/pybind11
Standards-Version: 3.9.2

Package: ros-iron-pybind11-vendor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, pybind11-dev, ros-iron-ros-workspace
Description: Wrapper around pybind11.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-pybind11-vendor//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
